'**********************************************************
'*@\	F	i}N
'*		F	i.comAPI𗘗pi}N
'*XV
'*	[XV]	[XV]	[XVe]
'*	2006/10/28	~g		VK쐬
'*
'**********************************************************

On Error Resume Next

'ݒ
Const MSG_TITLE	= "i"	'^Cg

'ϐ`
Dim	objKakaku4SE
Dim objXmlHttp
Dim objXmlDom
Dim strKeyword
Dim strCategory
Dim strSort
Dim strResult
Dim IntPage
Dim strUrl
Dim strResXml

'**********************************************************
'
'**********************************************************
Set objKakaku4SE	= CreateObject("Kakaku4SE.ItemSearch")
Set objXmlHttp		= CreateObject("Microsoft.XMLHTTP")
Set objXmlDom		= CreateObject("Msxml2.DOMDocument")
IntPage = 1

'Cďo
Call Main()

'G[
If Err.Number <> 0 Then
	Call PopUpMessage(Err.Description, vbCritical, MSG_TITLE)
	Err.Clear
End If

Call NothingAllObjects()

'**********************************************************
'C
'**********************************************************
Sub Main()

	On Error Resume Next

	strKeyword = Editor.GetSelectedString(CLng(0))

	If objKakaku4SE.Show(strKeyword, strCategory, strSort, strResult) = False Then
		Exit Sub
	End If
	
	strUrl = "http://api.kakaku.com/Ver1/ItemSearch.asp?Keyword=" & UrlEncode(strKeyword) & "&ResultSet=" & strResult & "&CategoryGroup=" & strCategory
	If strSort <> "" Then
		strUrl = strUrl & "&SortOrder=" & strSort
	End If
	strUrl = strUrl & "&PageNum=" & IntPage
	
	objXmlHttp.open "GET", strUrl, False
	objXmlHttp.send Null

	'G[
	If Err.Number <> 0 Then
		Exit Sub
	End If
	
	strResXml = objXmlHttp.responseText
	
	objXmlDom.loadXML strResXml

	'G[
	If Err.Number <> 0 Then
		Exit Sub
	End If
	
	If objXmlDom.parseError.errorCode <> 0 Then
		Exit Sub
	Else
		Editor.Down(CLng(0))
		Call Editor.InsText(CStr(DispDatas(objXmlDom.childNodes)))
	End If

	'G[
	If Err.Number <> 0 Then
		Exit Sub
	End If

End Sub

'**********************************************************
'DispDatas
'**********************************************************
Function DispDatas(objNode)
	Dim objTemp
	Dim strRet
	strRet = ""
	For Each objTemp In objNode
		If objTemp.nodeType = 3 Then
			strRet = strRet & objTemp.parentNode.nodeName & ":" & objTemp.nodeValue & vbCrLf
		End If
		If objTemp.hasChildNodes Then
			strRet = strRet & DispDatas(objTemp.childNodes)
		End If
	Next
	DispDatas = strRet
	Set objTemp = Nothing
End Function

'**********************************************************
'URLEncode
'**********************************************************
Function UrlEncode(ByVal strWord)
	Dim intIndex
	Dim strRet
	Dim strChar
	Dim strHex
	Dim regEx
	
	Set regEx = New RegExp
	regEx.Pattern = "[\-+\*/,\.0-9a-z]"
	regEx.IgnoreCase = True
	
	strRet = ""
	For intIndex = 1 To Len(strWord)
		strChar = Mid(strWord, intIndex, 1)
		If regEx.Test(strChar) = False Then
			strHex = Right("0000" & Hex(Asc(strChar)), 4)
			If Left(strHex, 2) = "00" Then
				strRet = strRet & "%" & Left(strHex, 2)
			Else
				strRet = strRet & "%" & Left(strHex, 2) & "%" & Right(strHex, 2)
			End If
		Else
			strRet = strRet & strChar
		End If
	Next
	Set regEx = Nothing
	
	UrlEncode = strRet
End Function

'**********************************************************
'IuWFNg̑S
'**********************************************************
Sub NothingAllObjects()
	'SẴIuWFNgLq
	Call InitializeArgument(objKakaku4SE)
	Call InitializeArgument(objXmlHttp)
	Call InitializeArgument(objXmlDom)
End Sub
'**********************************************************
'bZ[W{bNX
'**********************************************************
Sub PopUpMessage(strMsg, lngMode, strTitle)
	Dim objWshShell
	
	Editor.SearchClearMark(0)
	Set objWshShell = CreateObject("WScript.Shell")
	Call objWshShell.Popup(strMsg, lngMode, strTitle)
	Set objWshShell = Nothing
	
End Sub
'**********************************************************
'Cvbg{bNX
'**********************************************************
Function vbInputBox(strPrompt, strTitle, strDefault)
	Dim objKakaku4SECommon
	
	Set objKakaku4SECommon = CreateObject("Kakaku4SE.Common")
	vbInputBox = objKakaku4SECommon.vbInputBox(CStr(strPrompt), CStr(strTitle), CStr(strDefault))
	Set objKakaku4SECommon = Nothing
	
End Function
'**********************************************************
'bZ[W{bNX
'**********************************************************
Function vbMsgBox(strPrompt, intButtons, strTitle)
	Dim objKakaku4SECommon
	
	Set objKakaku4SECommon = CreateObject("Kakaku4SE.Common")
	vbMsgBox = objKakaku4SECommon.vbMsgBox(CStr(strPrompt), CInt(intButtons), CStr(strTitle))
	Set objKakaku4SECommon = Nothing
	
End Function
'**********************************************************
'R}h̎s
'	IntWindowStyle		0	HIDE
'						1	
'						2	ŏ
'						3	ő剻
'						4	ʂ̔ANeBu
'						5	ftHg
'						6	悭킩
'						7	ŏ̔ANeBu
'						8	悭킩
'						9	悭킩
'	blnWaitOnReturn		True	s҂
'						False	s҂Ȃ
'**********************************************************
Sub ExecCommand(strCommand, intWindowStyle, blnWaitOnReturn)
	Dim objWshShell
	
	Set objWshShell = CreateObject("WScript.Shell")
	Call objWshShell.Run(CStr(strCommand), CInt(intWindowStyle), CBool(blnWaitOnReturn))
	Set objWshShell = Nothing
	
End Sub
'**********************************************************
'oCg擾
'**********************************************************
Function GetByte(strChktxt)
	Dim lngIndex3
	Dim intCode2
	Dim lngBytes  
	If strChktxt = "" Then
			GetByte = -1
			Exit Function
	End If
	lngBytes = 0
	For lngIndex3 = 1 To Len(strChktxt)
		'ASCIIR[hɕϊ
		intCode2 = Asc(Mid(strChktxt, lngIndex3,1))
		If (( intCode2 >= 0) And (intCode2 <= 255)) Then
			lngBytes = lngBytes + 1		'p
		Else
			lngBytes = lngBytes + 2		'Sp
		End If
	Next
	GetByte = lngBytes
End Function
'******************************************************************************
'
' @\      : ϐԂɖ߂
'
' Ԃl    : Ȃ
'
'     : vntArgument : Ԃɖ߂ϐ
'
' @\  : IuWFNg^ȊO̕ϐvbEmptyɂ
'             ADODB.Recordset^ȊÕIuWFNgϐNothingCvbEmptyɂ
'             ADODB.Recordset^̃IuWFNgϐ͊JĂCloseCNothingCvbEmptyɂ
'
' l      : oAg^p(VBScript̕ϐ͑SăoAg^)
'
' XV  : 
'			[]		[XV]		[]
'			2004/03/04	V		VK쐬
'
'******************************************************************************
Public Sub InitializeArgument(ByRef vntArgument)
    Const adStateClosed = 0 'ADO萔FIuWFNgĂ邱Ƃ܂B
	
	On Error Resume Next
	
	'Empty`FbN
	If IsEmpty(vntArgument) Then
		Exit Sub
	End If
	'ϐ̎ނŏ
	Select Case VarType(vntArgument)
	Case vbObject, vbDataObject
		'IuWFNg^CnkdIuWFNg^̏ꍇ
		'IuWFNg͔jĂ邩`FbN
		If Not vntArgument Is Nothing Then
			'^`FbNCꂼ̏Is
			Select Case TypeName(vntArgument)
			Case "Recordset"
				'ADO.RecordsetIuWFNg
				'Ă邩`FbN
				If vntArgument.State <> adStateClosed Then
					'
					vntArgument.Close
				End If
			End Select
			'IuWFNgj
			Set vntArgument = Nothing
		End If
	End Select
	'
	vntArgument = vbEmpty
End Sub
'******************************************************************************
'
' @\      : VBAIIfƓ
'
' Ԃl    : 
'
'     : blnCase       : True / False
'             vntValueTrue  : blnCaseTrue̖̎߂l
'             vntValueFalse : blnCaseFalse̖̎߂l
'
' @\  : VBAIIfƓ
'
' l      : 
'
' XV  : 
' XV  : 
'			[]		[XV]		[]
'			2004/03/04	V		VK쐬
'
'******************************************************************************
Public Function vbsIIf(ByVal blnCase, ByRef vntValueTrue, ByRef vntValueFalse)
	If blnCase Then
		vbsIIf = vntValueTrue
	Else
		vbsIIf = vntValueFalse
	End If
End Function
'******************************************************************************
'
' @\		:	̒l󂾂w肳ꂽlԂB
'				ȊO͂̂܂ܕԂ
'
' Ԃl	:	oAg^
'
' 	:	vntValue		:	Null,Empty,󕶎ǂfl
'				vntKaraValue	:	̏ꍇɕԂ
'
' @\	:	Nulli[ĂꍇC"0"ԂB
'				NullȊOi[ĂꍇĈ܂ܕԂB
'
' l      :	IsNull, IsEmpty, 󕶎`FbNs
'				NES̈Ӗ...
'				N : Null
'				E : Empty
'				S : nullString
'
' XV  : 
'			[]		[XV]		[]
'			2004/03/04	V		VK쐬
''
'******************************************************************************
Public Function NES2Value(ByVal vntValue, ByVal vntNESValue)
	If IsNull(vntValue) Or IsEmpty(vntValue) Or vntValue = "" Then
		NES2Value = vntNESValue
	Else
		NES2Value = vntValue
	End If
End Function
